#include <dos.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <alloc.h>
#include <conio.h>
#include <time.h>

struct REGPACK regp;
union  REGS reg;
FILE *fp;
int klammer,klammerMAX,a,b,c,i,f,Falti,d3,di4;
int minX=0,minY=0,maxx=640,maxy=480,maxe=16384,samples=8192;
long Status;
double Xmin,Xmax,rE,iM,d1,d2=0.0,Wert,Op1,m,t,MaX=16384.0;
double TWO_PI=2.0*M_PI;
double huge *real;    //Pointer auf Real - Array
double huge *imag;    //Pointer auf Imag.- Array
char formeln[46][80];
double numbers[256];
int  AnzahlFormeln;
char text[256];
char Formel[256];
char Text[256];
char KLtext[100][200];


//----------------------------------------------------------------------------
/* The program */
//samples = How many Real/Imag Numbers...
//power =  log10((double)samples) / log10((double)2.0);  =13 fr 8192 Samples
void fft()
{
	unsigned i1, i2, i3, i4, y;
	int	 loop, loop1, loop2, power=13; //Glckszahl...
	double	 a1, a2, b1, b2, z1, z2, v;

	/* Scale the data */

	for (loop = 0; loop < samples; loop++)  {
		real[loop] /= (double)samples;
		imag[loop] /= (double)samples;
	}

	i1 = samples >> 1;
	i2 = 1;
	v = TWO_PI * ((double)1.0 / (double)samples);

	for (loop = 0; loop < power; loop++)  {
		i3 = 0;
		i4 = i1;

		for (loop1 = 0; loop1 < i2; loop1++)  {
			y = permute(i3 / i1);
			z1 =  cos(v * y);
			z2 = -sin(v * y);

			for (loop2 = i3; loop2 < i4; loop2++)  {
				a1 = real[loop2];
				a2 = imag[loop2];

				b1 = z1*real[loop2+i1] - z2*imag[loop2+i1];
				b2 = z2*real[loop2+i1] + z1*imag[loop2+i1];

				real[loop2]      = a1 + b1;
				imag[loop2]      = a2 + b2;

				real[loop2 + i1] = a1 - b1;
				imag[loop2 + i1] = a2 - b2;
			}

			i3 += (i1 << 1);
			i4 += (i1 << 1);
		}

		i1 >>= 1;
		i2 <<= 1;
	}
}

/*
 *	Bit reverse the number
 *
 *	Change 11100000b to 00000111b or vice-versa
 */

int permute(index)
int	index;
{
	int	n1, result, loop, power=13;  //Glckszahl

	n1 = samples;
	result = 0;

	for (loop = 0; loop < power; loop++)  {
		n1 >>= 1;			/* n1 / 2.0 */
		if (index < n1)
			continue;

		result += ((loop==0)?(1):(1<<loop));
		index -= n1;
	}

	return result;
}

/*
 *	Calculate Power Magnitude
 */

double magnitude(n)
int	n;
{
	n = permute(n);
	return (sqrt(real[n] * real[n] + imag[n] * imag[n]));
}


void inverseFFT()    //von mir!   (Lars Otte)
{
 int j;
 for(j=0;j<samples;j++) imag[j] = -imag[j];
 fft();
 for(j=0;j<samples;j++) imag[j] = -imag[j];
 for(j=0;j<samples;j++) real[j]*=8192.0,imag[j]*=8192.0;
}


void unscrambling()   //auch von mir, leider ein Speicherplatzverschwender!
{
 int j,h;
 for(j=0;j<samples;j++)
    {
     h=permute(j);
     real[samples+j] = real[h];
     imag[samples+j] = imag[h];
    }
 for(j=0;j<samples;j++)
    {
     real[j]=real[samples+j];
     imag[j]=imag[samples+j];
    }
}
//---------------------------------------------------------------------------



void Grafik(int GFXmode)  // 13,      14,     17mono,   18,      19vga,  3
{                         //320x200, 640x200, 640x480, 640x480, 320x200, text
   regp.r_ax = GFXmode;
   intr(0x10,&regp);
}



void Putpixel(int x, int y, int c)
{
 if(x<minX)return;
 if(y<minY)return;
 if(x>=maxx)return;
 if(y>=maxy)return;
 reg.h.ah = 0x0c;
 reg.h.al = c;
 reg.h.bh = 0;
 reg.x.cx = x;
 reg.x.dx = y;
 int86(0x10,&reg,&reg);
}



void TextXYC(int x,int y,int c,char *daten)
{
 int m;
 m=strlen(daten);
 regp.r_ax = 0x1300;
 regp.r_bx = c;
 regp.r_cx = m;
 regp.r_dx = x+256*y;
 regp.r_es = FP_SEG(daten);
 regp.r_bp = FP_OFF(daten);
 intr(0x10,&regp);
}



double Variables(int n)
{
if(n=='e')return M_E;
if(n=='p')return M_PI;
if(n=='m')return 2.0*M_PI;
if(n=='q')return M_PI*M_PI;
if(n=='l')return M_LN2;
if(n=='w')return M_SQRT2;
if(n=='v')return M_SQRT_2;
if(n=='d')return sqrt(3.0);
return 1.0;
}



void holeWert()
{
a=KLtext[klammer][b];  b++;
if(a==0) { printf("SYNTAX ERROR..."); getch(); Grafik(3); exit(1); }
if((a<48)||(a>']')) { Wert=numbers[a]; return; }
f=KLtext[klammer][b];  b++;
if(f==0) { printf("SYNTAX ERROR..."); getch(); Grafik(3); exit(1); }
Wert = numbers[f];
 if(a==48) Wert=sin(Wert);           //Funktionen
 if(a==49) Wert=asin(Wert);
 if(a==50) Wert=cos(Wert);
 if(a==51) Wert=acos(Wert);
 if(a==52) Wert=tan(Wert);
 if(a==53) Wert=atan(Wert);
 if(a==54) if(Wert>0.0)Wert=exp(-M_LN2*Wert); else Wert=0.0;  //exp
 if(a==55) Wert=log(Wert);
 if(a==56) Wert=log10(Wert);
 if(a==57){if(Wert!=0.0)Wert=sin(Wert)/Wert; else Wert=1.0; } //si
 if(a==58) Wert=sqrt(Wert);
 if(a==59) Wert=fabs(Wert);
 if(a==60)                         //dirac-Folge...
          {
           di4=1;  d1=fabs(Wert-((double)((long)Wert)));
           if(Wert>=0.0) { if(d1>d2)Wert=0.0; else Wert=1.0; }
           else          { if(d1>d2)Wert=1.0; else Wert=0.0; }
           d2=d1;
          }
 if(a==61){di4=1;  if(Wert==0.0)Wert=1.0; else Wert=0.0; }  //dirac
 if(a==62){if(fabs(Wert)<1.0)Wert=0.5+0.5*cos(M_PI*Wert); else Wert=0.0; } //Hanning
 if(a==63) Wert=exp(-M_LN2*Wert*Wert);     //gauss
 if(a==64){if((Wert>-1.0)&&(Wert<1.0))Wert=0.5*Wert+0.5; else Wert=0.0; } //ramp
 if(a==65){if((Wert>-1.0)&&(Wert<1.0))Wert=1-fabs(Wert); else Wert=0.0; } //dreieck
 if(a==66){if(Wert>=0.0)Wert=1.0; else Wert=0.0; } //Sprung
 if(a==67){if(Wert!=0.0) { if(Wert>0.0)Wert=1.0; else Wert=-1.0; } } //sgn
 if(a==68){if((Wert>-0.5)&&(Wert<=0.5))Wert=1.0; else Wert=0.0; }  //rect
 if(a==69)Wert=Wert*(((double)rand())/16383.5-1.0);    //noise
 if(a==70)Wert=random(Wert+1);
 if(a==71){if(Wert>1.0)Wert=1.0; if(Wert<-1.0)Wert=-1.0; }
}



double Algebra()
{
 for(klammer=0;klammer<klammerMAX;klammer++)
    {
     b=0;
     holeWert();
     Op1=Wert;

rechne:
     c=KLtext[klammer][b]; b++;    //Klammerkern auflsen
     if(c==0)goto Stopp;
     holeWert();
     if(c=='+')Op1+=Wert;
     if(c=='-')Op1-=Wert;
     if(c=='*')Op1*=Wert;
     if(c=='/')Op1/=Wert;
     if(c=='^')Op1=pow(Op1,Wert);
     goto rechne;
Stopp:

     numbers[klammer+128]=Op1;  //Zwischenergebnis
    }
return Op1;                     //Endergebnis
}



translate()       //bersetze ASCII 'text' zu Pseudo-Code 'Formel'
{
 int k,n,m,Anzahl=254;
 strcpy(Formel,"");
 for(k=0;k<256;k++)
    {
     if(text[k]==0)break;
     for(n=0;n<80;n++)           //erkenne Wrter
        {
         m=text[k+n];  Text[n]=0;
         if(m<'A')break;
         if(m>'z')break;
         if((m>'Z')&&(m<'a'))break;
         Text[n]=m;
        }
     if(n<2)
        {
         if((m>='0')&&(m<='9'))      //erkenne Ziffern
           {
            numbers[Anzahl]=atof( &(text[k]) );
            for(;k<256;k++)
               {
                if((text[k]>='0')&&(text[k]<='9'))continue;
                if(text[k]=='.')continue;         break;
               }
            k--;  text[k]=Anzahl;  Anzahl--;
           }
         n=strlen(Formel);
         Formel[n]=text[k];
         Formel[n+1]=0;
         continue;
        }
     k=k+n-1;
     for(n=0;n<AnzahlFormeln;n++)       //erkenne Funktionen
        {
         m=strcmp(Text,&(formeln[n][0]));
         if(m==0)break;
        }
     if(m!=0) { printf("\nERROR: '%s' unknown...",Text); return 1; }
     Text[1]=0; Text[0]=n+48; strcat(Formel,Text);
    }
for(k=0,n=0;k<256;k++)         //Klammern okay?
    {
     if(text[k]=='(')n++;
     if(text[k]==')')n--;
     if(text[k]==0)break;
    }
if(n!=0) { printf("\n() ERROR..."); return 1; }
t=0.0;  Grafik(3);   printf("y=");               //colorierte und komprimierte
for(k=0;k<256;k++)                               //Formel zeigen...
   {
    m=Formel[k];
    if(m==0)break;
    if(m=='t') m='x',Formel[k]=m;
    if(m>=128) { textcolor(10); cprintf("%lg",numbers[m]); continue; }
    if(m=='x') { textcolor(15);  cprintf("x"); continue; }
    if((m>='a')&&(m<='z')) { textcolor(2); numbers[m]=Variables(m); cprintf("%lg",numbers[m]); continue; }
    if((m>'/')&&(m<'^')) { printf("%s",&(formeln[m-48][0]));  continue; }
    if((m=='(')||(m==')')) textcolor(7); else textcolor(4);
    cprintf("%c",m);
   }                                            //Klammerung kompilieren...
for(klammerMAX=0;klammerMAX<100;klammerMAX++)
   {
    for(k=0,n=0,m=0,Anzahl=0;k<256;k++)         //Klammerlevel analysieren
       {
        if(Formel[k]=='(')n++;
        if(Formel[k]==')')n--;
        if(n>Anzahl)Anzahl=n,m=k;
        if(Formel[k]==0)break;
       }
    if(Anzahl==0)m--;
    for(k=0;k<200;k++)                    //1 klammerlose Formel erzeugen...
       {
        n=Formel[k+m+1];
        if(n==')')n=0;
        KLtext[klammerMAX][k]=n;
        if(n==0)break;
       }
    if(Anzahl==0)break;
    for(n=m;n<256;n++)Formel[n]=Formel[n+k+1]; //Ursprungsformel vereinfachen
    Formel[m]=klammerMAX+128;            //Zwischenergebnis Variable einfgen
   }
klammerMAX++;     printf(";\n");             //complierten Code zeigen...
window(1, wherey(), 80, 25);  printf("\n");
for(klammer=0;klammer<klammerMAX;klammer++)
   {
    textcolor(1); if(klammer<(klammerMAX-1))cprintf("[%d]",klammer);
    else cprintf("[y]");  printf("=");  strcpy(Formel,KLtext[klammer]);
    for(k=0;k<256;k++)
       {
        m=Formel[k];
        if(m==0)break;
        if(m>=192) { textcolor(10); cprintf("%lg",numbers[m]); continue; }
        if(m>=128) { textcolor(1); cprintf("[%d]",m-128); continue; }
        if(m=='x') { textcolor(15);  cprintf("x"); continue; }
        if((m>='a')&&(m<='z')) { textcolor(2); numbers[m]=Variables(m); cprintf("%lg",numbers[m]); continue; }
        if((m>'/')&&(m<'^')) { printf("%s",&(formeln[m-48][0]));  continue; }
        if((m=='(')||(m==')')) textcolor(7); else textcolor(4);
        cprintf("%c",m);
       }
    printf(";\n");
   }
 return 0;
}




void main()
{
double far  *Freal;
double far  *Fimag;   /* returned by memory allocation functions */
if((Freal=farcalloc(16385,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
if((Fimag=farcalloc(16385,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
real=Freal;
imag=Fimag;
randomize();
directvideo=0;
strcpy(formeln[0],"sin");
strcpy(formeln[1],"Arcsin");
strcpy(formeln[2],"cos");
strcpy(formeln[3],"Arccos");
strcpy(formeln[4],"tan");
strcpy(formeln[5],"Arctan");
strcpy(formeln[6],"exp");
strcpy(formeln[7],"ln");
strcpy(formeln[8],"log");
strcpy(formeln[9],"Si");
strcpy(formeln[10],"Wurzel");
strcpy(formeln[11],"abs");
strcpy(formeln[12],"diracs");
strcpy(formeln[13],"dirac");
strcpy(formeln[14],"Hanning");
strcpy(formeln[15],"gauss");
strcpy(formeln[16],"ramp");
strcpy(formeln[17],"dreieck");
strcpy(formeln[18],"Sprung");
strcpy(formeln[19],"sgn");
strcpy(formeln[20],"rect");
strcpy(formeln[21],"noise");
strcpy(formeln[22],"data");
strcpy(formeln[23],"clip");
AnzahlFormeln=24;
loopy:
Grafik(18);
for(i=0;i<AnzahlFormeln;i++)TextXYC(20*(i&3),(i/4)*2+3,14,&(formeln[i][0]));
TextXYC(0,((i-1)/4)*2+5,14,"+ - * / ^ () #             x t   e=e  p=  m=2  q=  l=ln2  w=2  v=1/2  d=3");
for(i=0;i<640;i++)
   {
    m=((double)i)/640.0*M_PI;   //Intro
    Putpixel(i,360.0-120.0*sin(2.0*m),1);
    Putpixel(i,360.0-60.0*sin(4.0*m),2);
    Putpixel(i,360.0-30.0*sin(8.0*m),3);
    Putpixel(i,360.0-15.0*sin(16.0*m),4);
   }
strcpy(Formel,"");  printf("Formel:");  scanf("%s",&text);  fflush(stdin);
for(i=0;i<256;i++)if((text[i]=='#')||(text[i]==0))break;
//----------------------------------------------------------------------------
if(text[i]=='#')                                          //Faltung?
  {
   printf("Xmin=");  scanf("%lg",&Xmin);  fflush(stdin);
   printf("Xmax=");  scanf("%lg",&Xmax);  fflush(stdin);
   if(Xmin>=Xmax) { printf("Range ERROR..."); getch(); Grafik(3); return; }
   for(i=0;i<samples;i++) real[samples+i]=1.0, imag[samples+i]=0.0;
   for(i=0,Status=0;i<256;i++)    //wieviele Faltungen?
      {
       if(text[i]=='#')Status++;
       if(text[i]==0)break;
      }
   m = (Xmax-Xmin) / ((double)samples);

   for(Falti=0;Falti<(Status+1);Falti++)   //jetzt beginnt die Faltung
      {
       for(i=0;i<256;i++)if((text[i]=='#')||(text[i]==0))break; //zerstckeln
       text[i]=0;  i=translate();  window(1,1,80,25);
       d2=0.0;     di4=0;          Grafik(18);
       if(i==1) { getch();  Grafik(3); return; }
       for(i=0;i<maxx;i++)Putpixel(i,240,1);
       d3=1; if(Xmin>0.0)d3=7;
       for(i=0;i<samples;i++)                           //Hauptrechenschleife
          {
           numbers['x']=((double)i)*m;
           if(d3==7)numbers['x']+=Xmin;
           if(numbers['x']>=Xmax) { if(d3)d2=1e66,d3=0; numbers['x']-=(Xmax-Xmin); }
           real[i]=Algebra();     imag[i]=0.0;
           if((real[i]>9.9)&&(real[i]<-9.9))continue;
           Putpixel(i/12.818,(240.0-48.0*real[i]),2);
          }
       if(di4)for(i=0;i<samples;i++)            //Korrektur fr Diracste
                {
                 real[i]*=(((double)samples)/(Xmax-Xmin));
                 imag[i]*=(((double)samples)/(Xmax-Xmin));
                }
       printf("FFT");       fft();                             //FFT
       for(i=0;i<samples;i++)
          {
           rE=real[samples+i];  iM=imag[samples+i]; //komplexe Multiplikation
           real[samples+i]=rE*real[i] - iM*imag[i];
           imag[samples+i]=rE*imag[i] + iM*real[i];
          }
       for(i=0;i<256;i++)if(text[i]==0)break;   //nchstes Formelstck...
       for(f=0;f<256;f++)text[f]=text[f+i+1];
      }
   Grafik(3);  gotoxy(30,12);   printf("inverse FFT...");
   for(i=0;i<samples;i++)
      {
       real[i]=real[samples+i];
       imag[i]=imag[samples+i];
      }
   unscrambling();
   inverseFFT();
   unscrambling();
   m=pow((Xmax-Xmin),Status);  for(i=0;i<samples;i++) real[i]*=m;
   for(i=0;i<samples;i++)imag[i]=real[i];           //interpolate
   for(i=0;i<samples;i++)real[2*i]=imag[i];  real[16384]=real[0];
   for(i=0;i<samples;i++)real[2*i+1]=(real[2*i]+real[2*i+2])/2.0;
   Grafik(18);              for(i=0;i<maxx;i++)Putpixel(i,240,1);
   for(i=0;i<maxe;i++)
      {
       if((real[i]>9.9)&&(real[i]<-9.9))continue;
       Putpixel(i/25.638,(240.0-48.0*real[i]),2);
      }
   goto beenden;
  }
//----------------------------------------------------------------------------
i=translate();  if(i==1) { getch();  Grafik(3);  return; }   //keine Faltung!
printf("Xmin=");  scanf("%lg",&Xmin);  fflush(stdin);
printf("Xmax=");  scanf("%lg",&Xmax);  fflush(stdin);
window(1,1,80,25);
if(Xmin>=Xmax) { printf("Range ERROR..."); getch(); Grafik(3); return; }
m=(Xmax-Xmin)/MaX;   d2=0.0;   Grafik(18);
if(Xmax==-Xmin)
  {
   for(i=0;i<maxy;i+=4)Putpixel(0,i,2);
   for(i=0;i<maxy;i+=4)Putpixel(639,i,2);
   for(i=0;i<maxy;i+=4)Putpixel(320,i,4);
  }
for(i=0;i<maxx;i++)Putpixel(i,240,1);
d3=1; if(Xmin>0.0)d3=7;
for(i=0;i<maxe;i++)                            //Hauptrechenschleife
   {
    numbers['x']=((double)i)*m;
    if(d3==7)numbers['x']+=Xmin;
    if(numbers['x']>=Xmax) { if(d3)d2=1e66,d3=0; numbers['x']-=(Xmax-Xmin); }
    real[i]=Algebra();
    if((real[i]>9.9)&&(real[i]<-9.9))continue;
    Putpixel(i/25.638,(240.0-48.0*real[i]),2);
    if(Xmax==-Xmin)
      {
       if(i>=8192)Putpixel((i-8192)/25.638,(240.0-48.0*real[i]),4);
       else       Putpixel((i+8192)/25.638,(240.0-48.0*real[i]),4);
      }
   }

beenden:
printf("Esc  Del  Enter");
while(kbhit())getch();
i=getch();  if(i==0)getch();                        //Ergebnis okay???
if((i!=13)&&(i!=27)) { Grafik(3); goto loopy; }
if(i==13)                                //abspeichern als TEMP.FFT
  {
   printf("\n\nwriting...");
   fp=fopen("TEMP.FFT","wb");  if(fp==NULL)return;
   Status=0;         fwrite(&Status,4,1,fp);
   Status=16384;     fwrite(&Status,4,1,fp);
   Status=8192;      fwrite(&Status,4,1,fp);
   Status=8192;      fwrite(&Status,4,1,fp);
   m=16384.0/(Xmax-Xmin); fwrite(&m,8,1,fp);
   for(i=0;i<8192;i++)imag[i]=real[2*i];
   fwrite(imag,8,8192,fp);
   for(i=0;i<8192;i++)imag[i]=real[2*i+1];
   fwrite(imag,8,8192,fp);
   fclose(fp);
  }
farfree(Freal);
farfree(Fimag);
Grafik(3);
}
