#include <dos.h>
#include <alloc.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <vga&bmp.h>
#include <string.h>

extern unsigned _stklen;

extern int MausX,MausY;                               //GrafikCursor-Position
extern int maxx,maxy;                //maximaler Wert fuer X/Y im Grafikmodus
extern int Farbe[20];    // 0-9=Farbe,10-19=Reserviert, siehe auch INI-Datei!
extern char AktuellName[81];                       //Name der gewhlten Datei
extern char AktuellText[81];              //  Name  der ausgewhlten Funktion
extern double Puffer[1024];                         //Bildschirm-Daten-Puffer


double Samplerate=11000.0;             //Abtastrate im Zeitbereich
long AnzahlNormal;                     //Anzahl Abtastwerte   wenn Stereo=0
long AnzahlReal;                       //Anzahl Realwerte     wenn Stereo=1
long AnzahlImag;                       //Anzahl Imaginrwerte wenn Stereo=1
int Stereo=0;                          //Real & Imaginr, Stereo=1;
int Nykill=0;                          //Nyquistkr=Samplerate/2 wenn Nykill=0
extern int FFTflag;                    //Zeitbereich = 0, Frequenzbereich = 1

double huge *real;    //Pointer auf Real - Array
double huge *imag;    //Pointer auf Imag.- Array
unsigned long size;   //maximale Anzahl der Arrayelemente



extern void Zeichensatz();
extern void Grafik(int o);
extern void Maus(int o);
extern void saveBMP(int o);
extern int GrafikCursor(int b);
extern int GrafikCursorShow(int b,int z);
extern int GrafikCursorDraw(int b);
extern int GrafikCursorLine(int Xx,int Yy);
extern int GrafikCursorWindow(int Xx,int Yy);
extern void MausPosition(int xx,int yy);
extern int inkey(int o);
extern void zeigeHilfe(char *dateiname);
extern int zeigeMenu();
extern int huge lese_INI_Datei();
extern int zeigeDatei(char *dateiname);
extern void Directory(char *dirEXT,int o);
extern void Kill();



void SOUND_Import(int B16)   //0 = 8bit,  1 = 16bit
{                            //importiert SOUND-Dateien, z.b:
 FILE *fp;                   //WAV VOC SND RAW IFF AU MAT SAM
unsigned long rID;           //es ist nur der Header von WAV-Dateien bekannt,
unsigned short nChannels;    //andere Dateien werden gem der INI-Datei behandelt...
  signed char s;
 int u,k,Smode=0,Channel2=0,Ydiv=1;
 double Rate=Farbe[18];
 long l,Foffset=0,Offset=0;
 Directory("*.WAV",0);   Directory("*.VOC",2);
 Directory("*.SND",2);   Directory("*.RAW",2);
 Directory("*.IFF",2);   Directory("*.AU" ,2);
 Directory("*.MAT",2);   Directory("*.SAM",2);
 k=zeigeDatei("TMP.TMP");  inkey(0);
if((k==27)||(k==0))return;
for(k=0;k<50;k++)if(AktuellName[k]==0)AktuellName[k]='.',u=256*AktuellName[k+1]+AktuellName[k+2];
for(k=0;k<50;k++)if(AktuellName[k]==' ')AktuellName[k]=0;
fp=fopen(AktuellName,"rb");  if(fp==NULL)return;
fseek(fp,0,2);  l=ftell(fp);  rewind(fp);

while(u==('W'*256+'A'))   //WAV or something else?
     {
      fread(&rID,1,4,fp);
      if(rID!=0x46464952)break; //Not a RIFF format file
      fread(&rID,1,4,fp);
      fread(&rID,1,4,fp);
      if(rID!=0x45564157)break; //Not a WAVE format chunk
      for(k=0;k<999;k++)
         {
          u=fgetc(fp);
          if(u!='f')continue;
suchM:    u=fgetc(fp);
          if(u=='f')goto suchM; //retriggern 'fmt '
          if(u!='m')continue;
          u=fgetc(fp);
          if(u=='f')goto suchM; //retriggern 'fmt '
          if(u!='t')continue;
          u=fgetc(fp);
          if(u=='f')goto suchM; //retriggern 'fmt '
          if(u!=' ')continue;
          break;
         }
      if(k==999)break; //Not a fmt WAVE Format Chunk
      fread(&rID,1,4,fp);
      fread(&nChannels,1,2,fp);
      if(nChannels!=1)break; //Data is not PCM
      fread(&nChannels,1,2,fp);
      if((nChannels!=1)&&(nChannels!=2))break; //Must be MONO or STEREO
      if (nChannels==2) Channel2 = 1;
      fread(&rID,1,4,fp); Rate = rID;
      fread(&rID,1,4,fp); //stereo Samplerate ( 2 * Mono Samplerate )
      fread(&nChannels,1,2,fp); //Byte aligment
      fread(&nChannels,1,2,fp); //Bits per Sample
      if(nChannels== 8)B16=0;
      if(nChannels==16)B16=1;
      fread(&rID,1,4,fp);    // 'data'
      fread(&rID,1,4,fp);    // How many data's
      l=rID;
      Foffset=ftell(fp);
      break;
     }
sprintf(AktuellText,"%s   %dbit   %lddatas   %lgHz   %.4lgs",AktuellName,8+B16*8,l/(B16+1),Rate,((double)(l/(B16+1)))/Rate);
if(Channel2) strcat(AktuellText,"   Stereo");
if(B16) Ydiv=(65536L/maxy)+1;
Grafik(1);   Kill();
settextstyle(0,0,1);
setcolor(Farbe[2]); line(0,maxy/2,maxx,maxy/2);
setcolor(Farbe[3]); outtextxy(0,0,AktuellText);
outtextxy(0,maxy-8,"Tab  Esc"); setcolor(Farbe[1]);
for(k=0;k<=maxx;k++)
   {
    if(B16) fread(&u,1,2,fp);
    else { u=getc(fp)-128; if(Smode) u+=128,s=u,u=s; }
    Puffer[k]=maxy/2-u/Ydiv;
   }
for(k=0;k<maxx;k++)line(k,Puffer[k],k+1,Puffer[k+1]);
inkey(0);  SetMouseXRange(0,30000);

Nochmal:                    //looping for starting point selection with mouse
GetMouseStatus();
while((MouseButton==0)&&(!kbhit()))
     {
      GetMouseStatus();
      Offset=MouseX*2L*(B16+1L);
      if(rID==Offset)continue;
      rID=Offset;
      if(Offset>l-9) Offset=l-9;
      fseek(fp,Foffset+Offset+(B16&Smode),0);
      setcolor(Farbe[0]);
      for(k=0;k<maxx;k++)line(k,Puffer[k],k+1,Puffer[k+1]);
      setcolor(Farbe[2]); line(0,maxy/2,maxx,maxy/2);
      setcolor(Farbe[3]); outtextxy(0,0,AktuellText);
      outtextxy(0,maxy-8,"Tab  Esc"); setcolor(Farbe[1]);
      for(k=0;k<=maxx;k++)
         {
          if(B16) fread(&u,1,2,fp);
          else { u=getc(fp)-128; if(Smode) u+=128,s=u,u=s; }
          Puffer[k]=maxy/2-u/Ydiv;
         }
      for(k=0;k<maxx;k++)line(k,Puffer[k],k+1,Puffer[k+1]);
     }
rID=Offset+1;     k=MouseButton;
while(MouseButton)GetMouseStatus();
if(k==0)k=getch();
if(k==27)                      //escape?
         {
          MausPosition(0,0);
          SetMouseXRange(0,632);
          Grafik(0);
          fclose(fp);
          return;
         }
if(k > 1) { Smode^=1; goto Nochmal; }  //change between signed / unsigned
FFTflag=0,  Stereo=Channel2,  Samplerate=Rate,  Nykill=0;
fseek(fp,Foffset+Offset+(B16&Smode),0);                             // reading
for(AnzahlNormal=0;AnzahlNormal<(2L*((long)Farbe[17]));AnzahlNormal++)
   {
    if(B16) { k=fread(&u,1,2,fp); if(k<2)break; }
    else {
          u=getc(fp);
          if(u==EOF)break;
          if(Smode)s=u,u=s;  else u=u-128;
         }
    if ((AnzahlNormal&1))  imag[AnzahlNormal/2] = u;
    else                   real[AnzahlNormal/2] = u;
   }
AnzahlImag=AnzahlNormal/2;
AnzahlReal=AnzahlImag+(AnzahlNormal&1);
if(Stereo) AnzahlNormal = AnzahlNormal / 2;
MausPosition(0,0);
SetMouseXRange(0,632);
Grafik(0);
fclose(fp);
}



int Wahl3()  //Wahl des Datenformats, liefert -1 bei Abbruch, andernfalls
{            // 0 (Text)  ,  1 (Float)  ,  2 (double)   zurck!
 int c;
 Grafik(1);  Kill();  settextstyle(0,0,4);
 setcolor(Farbe[3]);
 outtextxy(102,(1*maxy)/6,"Text     *.(T)");
 outtextxy(102,(3*maxy)/6,"Float    *.(F)");
 outtextxy(102,(5*maxy)/6,"Double   *.(D)");
 setcolor(Farbe[2]);
 outtextxy(101,(1*maxy)/6-1,"Text     *.(T)");
 outtextxy(101,(3*maxy)/6-1,"Float    *.(F)");
 outtextxy(101,(5*maxy)/6-1,"Double   *.(D)");
 setcolor(Farbe[1]);
 outtextxy(100,(1*maxy)/6-2,"Text     *.(T)");
 outtextxy(100,(3*maxy)/6-2,"Float    *.(F)");
 outtextxy(100,(5*maxy)/6-2,"Double   *.(D)");
 c=GrafikCursor(100);
 inkey(0);
 Grafik(0);
 Zeichensatz();
 if(c==27)return -1;
 c=(3*MausY)/maxy;
 return c;
}



int loadALL(char *dateiname)  //ldt Datei mit angegebenen Namen im FFT-Format
{
 long l;
 FILE *fpo;
fpo=fopen(dateiname,"rb");
if (fpo==NULL) return 1;
 fread(&l,sizeof(long),1,fpo);
Stereo=l&1;  l=l/2;  FFTflag=l&1;  l=l/2;
Nykill=l&1;  l=l/2;
 fread(&AnzahlNormal,sizeof(long),1,fpo);
 fread(&AnzahlReal  ,sizeof(long),1,fpo);
 fread(&AnzahlImag  ,sizeof(long),1,fpo);
 fread(&Samplerate,sizeof(double),1,fpo);
fread(real,sizeof(double),AnzahlReal,fpo);
fread(imag,sizeof(double),AnzahlImag,fpo);
 fclose(fpo);
 return 0;
}



int saveALL(char *dateiname) //speichert alle Daten in der Datei, mit dem angegebenen Namen im FFT-Format
{
 long l=Stereo+(2*FFTflag)+(4*Nykill);
 FILE *fpo;
fpo=fopen(dateiname,"wb");
if (fpo==NULL) return 1;
 fwrite(&l,sizeof(long),1,fpo);
 fwrite(&AnzahlNormal,sizeof(long),1,fpo);
 fwrite(&AnzahlReal  ,sizeof(long),1,fpo);
 fwrite(&AnzahlImag  ,sizeof(long),1,fpo);
 fwrite(&Samplerate,sizeof(double),1,fpo);
fwrite(real,sizeof(double),AnzahlReal,fpo);
fwrite(imag,sizeof(double),AnzahlImag,fpo);
 fclose(fpo);
 return 0;
}



void Import(int o)   //importiert Daten im Text/Float/Double Format,
{                    //Import(0)  reelle Daten
 int z,s;            //Import(1)  nur Realteil
 char *stp;          //Import(2)  nur Imaginrteil
 long i=-1,t;        //Import(3)  Real- und Imaginrteil
 double b;
 float c;
 FILE *fp;
 z=Wahl3();  if(z<0) return;
 if(z==0)Directory("*.(T)",0);
 if(z==1)Directory("*.(F)",0);
 if(z==2)Directory("*.(D)",0);
 s=zeigeDatei("TMP.TMP");  inkey(0);
 if((s==27)||(s==0))return;
 if(z==0)strcat(AktuellName,".(T)");
 if(z==1)strcat(AktuellName,".(F)");
 if(z==2)strcat(AktuellName,".(D)");
 if(z==0)
         {
          fp=fopen(AktuellName,"rt");  if(fp==NULL)return;  //wieviel Daten?
          do { stp=fgets(AktuellName,80,fp); i++; } while(stp!=NULL);
          rewind(fp);
         }
     else
         {
          fp=fopen(AktuellName,"rb");  if(fp==NULL)return;  //wieviel Daten?
          fseek(fp,0,2);  i=ftell(fp)+1;  rewind(fp);
          if(z==1) i=i/4;
          if(z==2) i=i/8;
         }
if(o==3) i=i/2;  //erste Hlfte real, zweite Hlfte imag.
if(o==0)
        {
         if(i>(2*size))i=2*size;      //lese reelle Daten
         for(t=0;t<i;t++)
            {
             if(z==0) { fgets(AktuellName,80,fp); b=atof(AktuellName); }
             if(z==1) { fread(&c,sizeof(float),1,fp); b=(double)c; }
             if(z==2) fread(&b,sizeof(double),1,fp);
             if ((t&1)) imag[t/2]=b; else real[t/2]=b;
            }
         AnzahlNormal=i;  AnzahlImag=i/2;  AnzahlReal=AnzahlImag+(i&1);
         FFTflag=0;  Stereo=0;
        }
if(i>size) i=size;
if((o&1)==1)
        {
         for(t=0;t<i;t++)            //lese Realteil
            {
             if(z==0) { fgets(AktuellName,80,fp); b=atof(AktuellName); }
             if(z==1) { fread(&c,sizeof(float),1,fp); b=(double)c; }
             if(z==2) fread(&b,sizeof(double),1,fp);
             real[t]=b;
            }
         AnzahlReal=i;  AnzahlNormal=AnzahlReal;  FFTflag=0;  Stereo=1;
         if (AnzahlImag<AnzahlReal) AnzahlNormal = AnzahlImag;
        }
if((o&2)==2)
        {
         for(t=0;t<i;t++)            //lese Imaginrteil
            {
             if(z==0) { fgets(AktuellName,80,fp); b=atof(AktuellName); }
             if(z==1) { fread(&c,sizeof(float),1,fp); b=(double)c; }
             if(z==2) fread(&b,sizeof(double),1,fp);
             imag[t]=b;
            }
         AnzahlImag=i;  AnzahlNormal=AnzahlReal;  FFTflag=0;  Stereo=1;
         if (AnzahlImag<AnzahlReal) AnzahlNormal = AnzahlImag;
        }
Nykill=0;
fclose(fp);
}



void Export(int o)  //importiert Daten als Text/Float/Double Format,
{                   //Export(1)  nur Realteil
 int z;             //Export(2)  nur Imaginrteil
 long t,max;        //Export(3)  Alles (Komplex oder Reell)
 double b;
 float c;
 FILE *fp;
 z=Wahl3();  if(z<0) return;
 if(z==0)Directory("*.(T)",1);
 if(z==1)Directory("*.(F)",1);
 if(z==2)Directory("*.(D)",1);
 printf("\n\n\rName: ");  scanf("%8s",AktuellName);  inkey(0);
 for(t=0;t<50;t++)if(AktuellName[t]=='.')AktuellName[t]=0;
 if(z==0)strcat(AktuellName,".(T)");
 if(z==1)strcat(AktuellName,".(F)");
 if(z==2)strcat(AktuellName,".(D)");
 fp=fopen(AktuellName,"wb");  if(fp==NULL)return;

if((o==3)&&(Stereo==0))              //reelle Daten speichern
         {
          for(t=0;t<AnzahlNormal;t++)
            {
             if ((t&1)) b=imag[t/2]; else b=real[t/2];
             if(z==0) fprintf(fp,"%.12lg\r\n",b);
             if(z==1) { c=b; fwrite(&c,sizeof(float),1,fp); }
             if(z==2) fwrite(&b,sizeof(double),1,fp);
            }
        }

if((o==3)||(o==1))                  //Realteil speichern
         {
          if(Stereo==0) { fclose(fp); return; }      //Stop wenn reell!
          max=AnzahlReal; if(o==3)max=AnzahlNormal;
          for(t=0;t<max;t++)
             {
              b=real[t];
              if(z==0) fprintf(fp,"%.12lg\r\n",b);
              if(z==1) { c=b; fwrite(&c,sizeof(float),1,fp); }
              if(z==2) fwrite(&b,sizeof(double),1,fp);
             }
         }
if((o==3)||(o==2))                 //Imagirteil speichern
         {
          if(Stereo==0) { fclose(fp); return; }       //Stop wenn reell!
          max=AnzahlImag; if(o==3)max=AnzahlNormal;
          for(t=0;t<max;t++)
             {
              b=imag[t];
              if(z==0) fprintf(fp,"%.12lg\r\n",b);
              if(z==1) { c=b; fwrite(&c,sizeof(float),1,fp); }
              if(z==2) fwrite(&b,sizeof(double),1,fp);
             }
        }
fclose(fp);
}



