#include <dos.h>
#include <alloc.h>
#include <time.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <vga&bmp.h>
#include <string.h>
#define   MY_SIZE     double   /* or float or long double */
#define   MY_TYPE     huge     /* or far if data fits in two 64 K segments */

extern unsigned _stklen;

extern int grafdriver,Grafikmodi;                     //in Ruhe lassen
extern int MausX,MausY;          //X,Y Position des GrafikCursors (read only), setzen mit MausPosition(x,y);
extern int maxx,maxy;            //maximaler Wert fuer X,Y im Grafikmodus, Beispiel fr 640x480: maxx=639 maxy=479.
extern int Farbe[20];            // 0-9=Farbe, 10-16=Reserviert, 17=Anzahl/2 aus SOUND-Datei zu lesender Abtastwerte,
//18 = Samplerate fr VOC/SND/IFF/AU/RAW/SAM/MAT-Dateien, 19=Beginners/Professional Mode, siehe auch INI-Datei!
extern int  maxcommands;             //Anzahl der beim Start von FFT4WAVE angegebenen Commandline Optionen.
extern char CommandLine[10][80];     //String ARRAY mit Commandline Optionen, noch ungenutzt!
extern int  Aktuell;                      // Nummer der ausgewhlten Funktion (dieselbe Nummer wie in der INI-Datei)
extern char AktuellText[81];              //  Name  der ausgewhlten Funktion (der Text hinter der Nr. in der INI-Datei)
extern char AktuellName[81];                       //Name der gewhlten Datei ( siehe zeigeDatei(""); )
extern double Puffer[1024];                         //Bildschirm-Daten-Puffer, Temporrer Puffer!
extern int PufferMAX;                  //Bildschirm-Daten-Puffer Anzahl Werte, Anzahl Werte im temporren Puffer!
extern double huge *real;        //Pointer auf Real - Array, siehe IN-OUT.C
extern double huge *imag;        //Pointer auf Imag.- Array, siehe IN-OUT.C
extern unsigned long size;       //maximal zulssige Anzahl der Arrayelemente des Real oder Imag.Arrays (variabel!)
extern long AnzahlNormal;              //Anzahl gltiger Abtastwerte, siehe IN-OUT.C
extern long AnzahlReal;                //Anzahl Werte im Real - Array
extern long AnzahlImag;                //Anzahl Werte im Imag.- Array
extern int Stereo;                     //Reelle Daten: Stereo=0, Komplexe Daten (Real&Imag): Stereo=1.
extern int FFTflag;                    //Zeitbereich = 0, Frequenzbereich = 1
extern int Nykill;                     //default: Nykill=0, bei FFT reeller Daten ist Nykill=1.
extern double lr,or,ur,rr;             //Randwerte fr GrafikCursorShow...
extern double Samplerate;              //Abtastrate (Abtastwerte pro Sekunde)
extern double div_Y;                   //Amplitude eines DIV (Gitter_Y)
extern double Xrange,YrangeMAX,YrangeMIN,Yoff; //Scaleing Info (siehe Visual.c / Statistik())





extern void Kill();
extern void Grafik(int o);
extern void Maus(int o);
extern void saveBMP(int o);
extern void Zeichensatz();
extern int GrafikCursor(int b);
extern int GrafikCursorShow(int b,int z);
extern int GrafikCursorDraw(int b);
extern int GrafikCursorLine(int Xx,int Yy);
extern int GrafikCursorWindow(int Xx,int Yy);
extern void MausPosition(int xx,int yy);
extern int inkey(int o);
extern void zeigeHilfe(char *dateiname);
extern int zeigeMenu();
extern int huge lese_INI_Datei();
extern int zeigeDatei(char *dateiname);
extern void Directory(char *dirEXT,int o);
extern void SOUND_Import(int B16);
extern int loadALL(char *dateiname);
extern int saveALL(char *dateiname);
extern void Import(int o);
extern void Export(int o);
extern void   sing(MY_SIZE MY_TYPE *a, MY_SIZE MY_TYPE *b, long ntot, long n, long nspan, int isn);
extern void realtr(MY_SIZE MY_TYPE *a, MY_SIZE MY_TYPE *b, long half_length,int isn);
extern void fuellen(int ArT);
extern void ZooM(int o);
extern void Visual(int STmode);
extern void Yscale();




void HanningWindow()  //multipliziert die Daten mit einen verschobenen cos(),
{                     //auch als Hanning-Fenster bekannt. Es werden Reelle
int z;                //als auch Komplexe Daten untersttzt...
long w;               //diehnt zur Reduzierung des Leck-Effekts bei FFT!
double k,m;
clrscr();       _setcursortype(0);
gotoxy(20,10);  cprintf("Hanning Window = 0.5 - 0.5 cos(2t/T)");
gotoxy(20,15);  cprintf("continue (J/N) ? ");
Hanaris: z=inkey(2); if((z=='n')||(z==27))return;
if((z!='j')&&(z!='y')&&(z!=2)) goto Hanaris;
k=2.0*M_PI/((double)AnzahlNormal);
if (Stereo)
  {
   for(w=0;w<AnzahlNormal;w++)
      {
       m=0.5-0.5*cos(k*((double)w));
       real[w]=real[w]*m;
       imag[w]=imag[w]*m;
      }
   return;
  }
for(w=0;w<AnzahlNormal;w++)
   {
    m=0.5-0.5*cos(k*((double)w));
    if(w&1)imag[w/2L]*=m; else real[w/2L]*=m;
   }
}



void ZeroSwapping()  //vertauscht 0....Datenlnge/2-1  mit Datenlnge/2...Datenlnge!
{                                    //Datenlnge mu eine gerade Zahl sein!
long w,e=AnzahlNormal/2L;            //untersttzt Reelle und Komplexe Daten.
double m1,m2;
clrscr();  cprintf("swapping Zero...");
for(w=0;w<e;w++)
   {
    if(Stereo)m1=real[w],m2=imag[w],real[w]=real[w+e],imag[w]=imag[w+e],real[w+e]=m1,imag[w+e]=m2;
    else
        {
         if(w&1)m1=imag[w/2L]; else m1=real[w/2L];
         if((w+e)&1)m2=imag[(w+e)/2L]; else m2=real[(w+e)/2L];
         if(w&1)imag[w/2L]=m2; else real[w/2L]=m2;
         if((w+e)&1)imag[(w+e)/2L]=m1; else real[(w+e)/2L]=m1;
        }
   }
}



void Polar()    //umwandeln komplexer Daten von Polar nach Real&Imag.
{               //Daten im real Array = Betrge
 int z;         //Daten im imag Array = Winkel (0...360)
 long w;        //ob Zeitbereich oder Frequenzbereich ist vollkommen egal...
 double a,b;
 if (Stereo==0) return;
 clrscr(); gotoxy(1,10);
 _setcursortype(0);
 cprintf("Real = Amplitude           (J/N)           Real = Amplitude_real\n\r");
 cprintf("Imag.=  0...360         >        Imag.= Amplitude_imag.\n\n\n\n\n\r");
 Polaris:  z=inkey(2);  if((z=='n')||(z==27))return;
 if((z!='j')&&(z!='y')) goto Polaris;
 cprintf("waiting...");
 for(w=0;w<AnzahlNormal;w++)
    {
     a=real[w];  b=imag[w];
     b= b /180.0 * M_PI;
     real[w] = a * cos(b);
     imag[w] = a * sin(b);
    }
}



void Information(int o)   //Information(0)  vollstndiger Statusbericht
{                         //Information(1)  kurzer Statusbericht (Zeit/Freq.)
 int a=(maxx+1)/16;
 clrscr();
 cprintf("Status = ");
 if(FFTflag) cprintf("Freq.  [Hz]                             ");
 else cprintf("Zeit/Time  [s]                             ");
 if(o) return;
 if(Stereo)cprintf("\n\n\rReal & Imag. DATA Mode...");
 cprintf("\n\n\n\r%ld Abtastwerte/DATAs",AnzahlNormal);
 if(!FFTflag) cprintf(" = %lgs",AnzahlNormal/Samplerate);
 cprintf("\n\n\rmax. %lu Abtastwerte/DATAs",(Stereo>0)?(size):(size<<1));
 cprintf("\n\n\n\rSamplerate/Abtastrate = %lg  [1/s]\n\n\n\r",Samplerate);
 cprintf("Gitter_X / DIV_Dauer / DIV_Time  = %lgs\n\n\r",(a/Samplerate));
 cprintf("Gitter_Y / DIV_Amplitude = %lg\n\n\n\r",div_Y);
}



int holeFilename()    //zeigt alle FFT-Dateien an, und erwartet ihre Auswahl.
{                     //stimmt der Status der FFT-Datei nicht mit dem Status
int z;                //des Speichers berein (Fehler) liefert holeFilename 1
double d;                                         //und bei bereinstimmung 0
long AnzahlFNormal,l;     //der Dateiname wird ber AktuellName zurckgegeben
FILE *fpo;
 Directory("*.FFT",0);   z=zeigeDatei("TMP.TMP");   inkey(0);
 strcat(AktuellName,".FFT");  if((z==27)||(z<1))return 1;
 fpo=fopen(AktuellName,"rb");   if (fpo==NULL) return 1;
 clrscr();   fread(&l,sizeof(long),1,fpo);   z=((int)l);
 fread(&AnzahlFNormal,sizeof(long),1,fpo);
             fread(&l,sizeof(long),1,fpo);
             fread(&l,sizeof(long),1,fpo);
           fread(&d,sizeof(double),1,fpo);
 fclose(fpo);   if(Stereo!=(z&1))return 1;
 if(AnzahlNormal!=AnzahlFNormal) return 1;
 z=z/2;  if(FFTflag!=(z&1))cprintf("Verify Time & Freq!\n\r");
 z=z/2;  if( Nykill!=(z&1))cprintf("Nyquist type don't match\n\r");
 if(d!=Samplerate)cprintf("Samplerate1 (%lg) is not Samplerate2 (%lg)\n\r",Samplerate,d);
 return 0;
}



void absERROR()  //berechnet die Differenz:      MEMORY = MEMORY - NAME.FFT
{                //Subtraktion zwischen Daten im Speicher und Daten aus Datei.
int z;           //es werden Reelle und Komplexe Daten untersttzt...
double d;
long w,Areal,Aimag;
FILE *fpo;
 z=holeFilename();   gotoxy(1,8);   if(z)return;
 cprintf("%s = %ld exact data...\n\n\n\n\r",AktuellName,AnzahlNormal);
 cprintf("MEMORY = MEMORY - %s\n\n\n\n\r",AktuellName);
 cprintf("continue (J/N) ? ");
 absaris:  z=inkey(2);  if((z=='n')||(z==27))return;
 if((z!='j')&&(z!='y')) goto absaris;
 fpo=fopen(AktuellName,"rb");       if(fpo==NULL)return;
 fread(&w,sizeof(long),1,fpo);      fread(&w,sizeof(long),1,fpo);
 fread(&Areal,sizeof(long),1,fpo);  fread(&Aimag,sizeof(long),1,fpo);
 fread(&d,sizeof(double),1,fpo);    _setcursortype(0);
 for(w=0;w<Areal;w++)
    {
     fread(&d,sizeof(double),1,fpo);
     real[w]=real[w]-d;
    }
 for(w=0;w<Aimag;w++)
    {
     fread(&d,sizeof(double),1,fpo);
     imag[w]=imag[w]-d;
    }
 if(Stereo)AnzahlReal=AnzahlNormal,AnzahlImag=AnzahlNormal;
 fclose(fpo);
}




void makeFFT()    //fhrt die FFT/inverseFFT reeller oder komplexer Daten aus
{
int z;
long m,m2,m4,t;
double d1,d4;
clrscr();
gotoxy(1,10);
if(FFTflag)
   {
    cprintf("               inverse FFT\n\r");
    cprintf("Freq. [Hz]  >  Zeit/Time  [s]");
   }
else
   {
    cprintf("                   F F T\n\r");
    cprintf("Zeit/Time [s]  >  Freq. [Hz]");
   }
cprintf("\n\n\n\n\n\rcontinue (J/N) ? ");
absaris: z=inkey(2);  if((z=='n')||(z==27))return;
if((z!='j')&&(z!='y')&&(z!=2)) goto absaris;
clrscr();  _setcursortype(0);  gotoxy(27,12);
cprintf("Fast  Fourier  Transformation\n\n\r");
m=AnzahlNormal;
m2=m/2;  m=2*m2;
AnzahlNormal=m;
d1=m; d4 = 2.0 * d1;
if(FFTflag)                 //freq --> time
  {
   if (Stereo)
     {
      if(Nykill==0) sing(real,imag,m,m,m,1);       //complexe inverse FFT
      else
          {                //inverse FFT, von FFT-transfomierten reellen Daten
           realtr(real,imag,m,1);
           sing(real,imag,m,m,m,1);
           Stereo=0;  Nykill=0;  Samplerate*=2.0;
           AnzahlNormal=2*m;
          }
     }
  }
if(FFTflag==0)              //time --> freq
  {
   if(Stereo)
       {
        sing(real,imag,m,m,m,-1);                      //complexe FFT
        for(t=0;t<m;t++) real[t]/=d1,imag[t]/=d1;
       }
   else
       {
        real[m2]=0.0,imag[m2]=0.0;                     //reelle   FFT
        sing(real,imag,m2,m2,m2,-1);
        realtr(real,imag,m2,-1);
        for(t=0;t<m2;t++) real[t]/=d4,imag[t]/=d4;
        Stereo=1;  Nykill=1;  Samplerate/=2.0;
        AnzahlNormal=m2, AnzahlReal=m2, AnzahlImag=m2;
       }
  }
FFTflag^=1;
}



void Faltung()      //Faltung:      MEMORY = MEMORY * NAME.FFT
{                   //Faltung zwischen Daten im Speicher und Daten aus Datei.
int z;              //es werden nur komplexe Daten untersttzt...
double d,e,r,i;
long w,l,Areal,Aimag;
FILE *fpo;
 if(Stereo==0)return;
 z=holeFilename();   gotoxy(1,8);   if(z)return;
 cprintf("%s = %ld exact data...\n\n\n\n\r",AktuellName,AnzahlNormal);
 cprintf("MEMORY = MEMORY * %s\n\n\n\n\r",AktuellName);
 cprintf("continue (J/N) ? ");
 Faltaris:  z=inkey(2);  if((z=='n')||(z==27))return;
 if((z!='j')&&(z!='y')) goto Faltaris;
 _setcursortype(0); cprintf("\n\n\rFFT of Memory");
 l=AnzahlNormal/2L;  l=l*2L;  d=(double)l;  AnzahlNormal=l;   //FFT of Memory
 sing(real,imag,l,l,l,-1);    cprintf(", writing...");
 fpo=fopen("TMP.TMP","wb");   if(fpo==NULL)return;     //speichern in TMP.TMP
 for(w=0;w<l;w++)
    {
     r=real[w]/d;        i=imag[w]/d;
     fwrite(&r,8,1,fpo);  fwrite(&i,8,1,fpo);
    }
 fclose(fpo);  cprintf("\n\n\rloading %s",AktuellName);
      fpo=fopen(AktuellName,"rb");      if(fpo==NULL)return;     //lade *.FFT
     fread(&w,sizeof(long),1,fpo);          fread(&w,sizeof(long),1,fpo);
 fread(&Areal,sizeof(long),1,fpo);      fread(&Aimag,sizeof(long),1,fpo);
   fread(&d,sizeof(double),1,fpo);      fread(real,sizeof(double),Areal,fpo);
 fread(imag,sizeof(double),Aimag,fpo);  fclose(fpo);   cprintf(", FFT...");
 d=(double)l;  sing(real,imag,l,l,l,-1);               //FFT of *.FFT Datei
 for(w=0;w<l;w++)real[w]/=d,imag[w]/=d;
 cprintf("\n\n\rMultiplikation...\n\n\r");
 fpo=fopen("TMP.TMP","rb");  if(fpo==NULL)return;      //Multipl. mit TMP.TMP
 for(w=0;w<l;w++)
    {
     fread(&r,8,1,fpo);  fread(&i,8,1,fpo);
     d=r*real[w] - i*imag[w];
     e=r*imag[w] + real[w]*i;
     real[w]=d;    imag[w]=e;
    }
 fclose(fpo);  cprintf("inverse FFT...");  sing(real,imag,l,l,l,1);
 AnzahlReal=AnzahlNormal,AnzahlImag=AnzahlNormal;
}



/****************************************************************************
Achtung:  Innerhalb der Menueschleife knnen Sie neue Funktionen einbinden!
etwa so:  if(Aktuell==neueFunktionsnummer) neueFunktion();
nicht vergessen die neue Funktionsnummer in der INI-Datei zu betiteln:
#neueFunktionsnummer  neuerFunktionsName
****************************************************************************/
int main( int argc, char *argv[] )
{
int i;
double far  *Freal;
double far  *Fimag;   /* returned by memory allocation functions */
size = farcoreleft()-9900;           //Speicher fuer real/imag Array belegen
size = size /sizeof(double) /2L;
if((Freal=farcalloc(size+3,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
if((Fimag=farcalloc(size+3,sizeof(double)))==NULL){printf("out of memory\n"); exit(0);}
real=Freal; imag=Fimag;
if(size<16384) { printf("out of memory\n"); exit(0); }
i=getdisk(); if(i<2) { printf("today is a good day to die..."); exit(0); }

grafdriver=DETECT;  //automatische Erkennung der Bildschirmkarte angefordert
maxcommands=argc;
for(i=0;i<argc;i++)strcpy(CommandLine[i],argv[i]); //ComandlineOptionen lesen

  /* registriert BGI Treiber, die zur  Link-Zeit hinzugebunden wurden */

installuserdriver("Svga16",lese_INI_Datei);
registerfarbgidriver(Svga16_fdriver);
Maus(1);    //Maus initialisieren!
printf("\nMemory: %ld\n\nreading  >TEMP.FFT<  ...",size);
loadALL("TEMP.FFT");
Grafik(1);  //Grafik einschalten (testen)
Grafik(0);

while(1)    //Anfang der Menueschleife
{
 inkey(0);
 Zeichensatz();
 i=zeigeMenu();
 inkey(0);
 if((i==315)||(i==2))zeigeHilfe("fft4wave.hlp");
 if(i==27) break;
 if(i!=1) continue;   //ab hier knnen Sie ihre eigenen Funktionen einbinden!
 if(Aktuell==60) Faltung();
 if(Aktuell==59) Visual(0);        //polar
 if(Aktuell==58) Visual(2);        //imag.
 if(Aktuell==57) Visual(1);        //real
 if(Aktuell==56) ZeroSwapping();
 if(Aktuell==55) absERROR();
 if(Aktuell==54) HanningWindow();
 if(Aktuell==53) Xscale();
 if(Aktuell==52) Yscale();
 if(Aktuell==51) Visual(3);        //real&imag.
 if(Aktuell==50) makeFFT();
 if(Aktuell==48) Export(2); //imag.
 if(Aktuell==47) Export(1); //real
 if(Aktuell==46) Export(3); //all
 if(Aktuell==45) Import(3); //real&imag.
 if(Aktuell==44) Import(2); //imag.
 if(Aktuell==43) Import(1); //real
 if(Aktuell==42) Import(0); //normal
 if(Aktuell==41)
                {
                 clrscr();  Directory("*.FFT",1);   printf("\n\n\rName: ");
                 scanf("%8s",AktuellName);    fflush(stdin);     inkey(0);
                 for(i=0;i<50;i++)if(AktuellName[i]=='.')AktuellName[i]=0;
                 strcat(AktuellName,".FFT");  saveALL(AktuellName);
                }
 if(Aktuell==40)
                {
                 Directory("*.FFT",0);   i=zeigeDatei("TMP.TMP");  inkey(0);
                 strcat(AktuellName,".FFT"); if((i!=27)&&(i>0))loadALL(AktuellName);
                }
 if(Aktuell==39) SOUND_Import(1);
 if(Aktuell==38) SOUND_Import(0);
 if(Aktuell==37)zeigeHilfe("fft4wave.hlp");
 if(Aktuell==36)
                {
                 Information(0); cprintf("Gesamtdauer / Fulltime: "); scanf("%lg",&Samplerate);
                 fflush(stdin); Samplerate=AnzahlNormal/Samplerate;  inkey(0);
                }
 if(Aktuell==35) { Information(0); cprintf("Gitter_Y / DIV_Amplitude: "); scanf("%lg",&div_Y); fflush(stdin); inkey(0); }
 if(Aktuell==34)
                {
                 Information(0); cprintf("Gitter_X / DIV_Time: "); i=(maxx+1)/16;
                 scanf("%lg",&Samplerate); fflush(stdin); Samplerate=i/Samplerate;  inkey(0);
                }
 if(Aktuell==33) { Information(0); cprintf("Samplerate: "); scanf("%lg",&Samplerate); fflush(stdin); inkey(0); }
 if(Aktuell==32) { FFTflag^=1; _setcursortype(0); Information(1); inkey(2); }
 if(Aktuell==31) { _setcursortype(0); Information(0); inkey(2); }
 if(Aktuell==30)   Polar();
 if(Aktuell==24) { Grafik(1); Kill(); fuellen(3); Grafik(0); }
 if(Aktuell==23) { Grafik(1); Kill(); fuellen(2); Grafik(0); }
 if(Aktuell==22) { Grafik(1); Kill(); fuellen(1); Grafik(0); }
 if(Aktuell==21) { Grafik(1); Kill(); fuellen(0); Grafik(0); }
 if(Aktuell<20) break;   //Ende der Menueschleife
}
Grafik(1); Grafik(0);   //IBM-Zeichensatz erzwingen...
if (i==27) Aktuell=19;  //Abruch mit Copyright Vermerk!
if (Aktuell>9)
  {
   printf("Fast-Fourier-Transformation for WAV-Files\n");
   printf("------------------------------------------\n\n");
   printf("copyright (c) 25.9.1994 by Lars Otte\n\n");
   printf("This is a Public Domain program !!!\n\n");
   printf("That means this progam cost nothing, feel free to use (or copy) it,\n");
   printf("so often you want. Use for   business / at work   is free too,\n");
   printf("but it is illegal to sell this program for more than 9$ (US).\n\n\n\n");
   saveALL("TEMP.FFT");
  }
Maus(0);
farfree(Fimag);
farfree(Freal);
return Aktuell;
}
