#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <vga&bmp.h>
#include <string.h>

extern unsigned _stklen;

extern Grafikmodi;                               //in Ruhe lassen
int MausX,MausY;                                //GrafikCursor-Position
extern int maxx,maxy;                //maximaler Wert fuer X/Y im Grafikmodus
int TempMausCursor[200];            //temporrer Cursorspeicher,temp.nutzbar
extern int Farbe[20];    // 0-10=Farbe,11-17=Reserviert,siehe auch INI-Datei!
extern int FFTflag;                    //Zeitbereich = 0, Frequenzbereich = 1
double lr=0,rr=1,or=1,ur=0,Zx=0.0,Zy=0.0;    //Randwerte fr GrafikCursorShow


extern void saveBMP(int o);


int GrafikCursor(int b)   //zeigt einen GrafikCursor der Gre b (4...100), Abbruch mit beliebiger Taste,
{                         //zurckliefert wird der OTTE-ASCII Wert der gedrcken Taste.
 int k,l=b/2;             //MausX und MausY enthlt die neue GrafikCursor-Position!
 CurLOOP:                 //die Tasten F9 und F10 bewirken einen Bildschirmausdruck in eine BMP-Datei.
 for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
 for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
 GetMouseStatus();
 while((!kbhit())&&(MouseButton==0))
      {
       GetMouseStatus();
       if((MouseX==MausX)&&(MouseY==MausY)&&(Grafikmodi==1))continue;
       if(((MouseX/8)==MausX)&&((MouseY/8)==MausY)&&(Grafikmodi>1))continue;
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
       if(Grafikmodi>1) MausX=MouseX/8,MausY=MouseY/8;
       else MausX=MouseX,MausY=MouseY;
       for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
       for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
      }
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
 k=MouseButton;
 if(k==0)                      //Wenn keine Maustaste gedrckt ist
	 {                     //dann wurde die Tastatur bettigt, also
	  k=getch();              //Hole Tastaturcode
	  if(k==0)k=getch()+256;  //Hole erweiterten Tastaturcode
          if((k==323)||(k==324)) { saveBMP(k-323); goto CurLOOP; }
	 }
return (k);
}




/*****************************************************************************
GrafikCursorShow zeigt in der Linken Oberen Ecke den Zahlenwert fr die
CursorPosition an, damit das Ganze einen Sinn ergibt kann man die Randwerte
des Bildschirms definieren: linker Rand = lr, Rechter Rand = rr,
oberer Rand = or, unterer Rand = ur; Es handelt sich selbstverstndlich um
Gleitkommawerte (double)!  Der Splitscreen-Mode teilt Y in 2 Bildschirme:

         or                              or1
normal:                       Splitscreen:  or2ur1
         ur                           ur2Ĵ
        lr      rr                              lr      rr

or1=or  or2=or  ur1=ur  ur2=ur; (soviel zum Splitscreen-Mode)
Die Tasten S X Y erlauben es einen neuen Nullpunkt ab CursorPosition zu setzen,
das ist sehr ntzlich wenn man auf dem Bildschirm Entfernungen messen mchte,
 'S'   setzt neuen Nullpunkt fr X und Y Richtung.
 'X'   setzt neuen Nullpunkt fr X Richtung.
 'Y'   setzt neuen Nullpunkt fr Y Richtung.
 'N'  und  'Z'     Null und Zero stellen den Normalzustand wieder her!
*****************************************************************************/
int GrafikCursorShow(int b,int z)   //zeigt einen GrafikCursor der Gre b (4...100), default:z=0 wenn z=1 dann Splitscreen(y/2)Mode;
{                                  //liefert den ASCII-Code der gedrckten Taste zurck (bei Maustasten=1...3)
 double lx,ly;                    //MausX und MausY enthlt die neue GrafikCursor-Position!
 int k,l=b/2, v=(maxy+1)/2;      //die Tasten F9 und F10 bewirken einen Bildschirmausdruck in eine BMP-Datei.
 char Text[80];
 char *TeXt = Text+40;
 ShowLOOP:
 strcpy(TeXt,""); strcpy(Text,""); settextstyle(0,0,1);
 for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
 for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
 GetMouseStatus();
 while((!kbhit())&&(MouseButton==0))
      {
       GetMouseStatus();
       if((MouseX==MausX)&&(MouseY==MausY)&&(Grafikmodi==1))continue;
       if(((MouseX/8)==MausX)&&((MouseY/8)==MausY)&&(Grafikmodi>1))continue;
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
       if(Grafikmodi>1) MausX=MouseX/8,MausY=MouseY/8;
       else MausX=MouseX,MausY=MouseY;
       lx=MausX; lx/=maxx; ly=MausY; ly/=maxy; if(z)ly=(MausY%v),ly/=(v-1);
       lx=lr+lx*(rr-lr);  ly=or-ly*(or-ur);
       setcolor(Farbe[0]);
       outtextxy(0,0,Text);
       outtextxy(0,8,TeXt);
       setcolor(Farbe[3]);
       sprintf(TeXt," %lg",ly-Zy); sprintf(Text," %lg",lx-Zx);
       if(FFTflag)strcat(Text,"Hz"); else strcat(Text,"s");
       if(Zx!=0.0)Text[0]=127;
       if(Zy!=0.0)TeXt[0]=127;
       outtextxy(0,0,Text);
       outtextxy(0,8,TeXt);
       for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
       for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
      }
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
    setcolor(Farbe[0]);   outtextxy(0,0,Text);
    outtextxy(0,8,TeXt);  setcolor(Farbe[3]);
 k=MouseButton;
 if(k==0)                      //Wenn keine Maustaste gedrckt ist
	 {                     //dann wurde die Tastatur bettigt, also
	  k=getch();              //Hole Tastaturcode
          if(k=='z') { Zx=0.0; Zy=0.0; goto ShowLOOP; }
          if(k=='n') { Zx=0.0; Zy=0.0; goto ShowLOOP; }
          if(k=='x') { Zx=lx;          goto ShowLOOP; }
          if(k=='y') {         Zy=ly;  goto ShowLOOP; }
          if(k=='s') { Zx=lx;  Zy=ly;  goto ShowLOOP; }
	  if(k==0)k=getch()+256;  //Hole erweiterten Tastaturcode
          if((k==323)||(k==324))
              {
               sprintf(Text,"\33%lg  \30%lg  \31%lg  \32%lg",lr,or,ur,rr);
               for(l=0;l<=maxx;l+=8) { putpixel(l,0,Farbe[3]); putpixel(l,maxy,Farbe[3]); }
               for(l=0;l<=maxy;l+=8) { putpixel(0,l,Farbe[3]); putpixel(maxx,l,Farbe[3]); }
               if(z)for(l=0;l<=maxx;l+=8) putpixel(l,v,Farbe[3]);
               putpixel(maxx,maxy,Farbe[3]);  outtextxy(24,3,Text);
               l=b/2; saveBMP(k-323); goto ShowLOOP;
              }
	 }
return (k);
}



int GrafikCursorDraw(int b)  //zeigt einen GrafikCursor der Gre b (4...100), Abbruch mit beliebiger Taste,
{                           //zurckgeliefert wird der OTTE-ASCII Wert der gedrckten Taste!
 int k,l=b/2;             //die linke Maustaste zieht Linien & setzt Punkte!
 int liX=0,liY=0;        //MausX und MausY enthlt die neue GrafikCursor-Position!
 DrawLoop:              //die Tasten F9 und F10 bewirken einen Bildschirmausdruck in eine BMP-Datei.
 for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
 for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
 while(!kbhit())
      {
       GetMouseStatus();
       if((MouseButton&3)>1)break;
       if(MouseButton==1)
         {
          if((liX!=MausX)||(liY!=MausY))
            {
             if((liX==0)&&(liY==0)) { liX=MausX; liY=MausY; TempMausCursor[l+b]=Farbe[1]; }
             else
                 {
                  for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
                  for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
                  setcolor(Farbe[1]);
                  line(liX,liY,MausX,MausY);
                  liX=MausX;
                  liY=MausY;
                  for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
                  for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
                  for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
                  for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
                 }
            }
          TempMausCursor[l+b]=Farbe[1];
         }
       if((MouseX==MausX)&&(MouseY==MausY)&&(Grafikmodi==1))continue;
       if(((MouseX/8)==MausX)&&((MouseY/8)==MausY)&&(Grafikmodi>1))continue;
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
       if(Grafikmodi>1) MausX=MouseX/8,MausY=MouseY/8;
       else MausX=MouseX,MausY=MouseY;
       for(k=0;k<b;k++)TempMausCursor[k]=getpixel(MausX+k-l,MausY);
       for(k=0;k<b;k++)TempMausCursor[k+b]=getpixel(MausX,MausY+k-l);
       for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,Farbe[10]);
       for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,Farbe[10]);
       if(MouseButton!=1)liX=MausX,liY=MausY;
      }
 for(k=0;k<b;k++)putpixel(MausX+k-l,MausY,TempMausCursor[k]);
 for(k=0;k<b;k++)putpixel(MausX,MausY+k-l,TempMausCursor[k+b]);
 k=MouseButton;
 if(k==0)                      //Wenn keine Maustaste gedrckt ist
	 {                     //dann wurde die Tastatur bettigt, also
	  k=getch();              //Hole Tastaturcode
	  if(k==0)k=getch()+256;  //Hole erweiterten Tastaturcode
          if((k==323)||(k==324)) { saveBMP(k-323); goto DrawLoop; }
	 }
return (k);
}



int GrafikCursorLine(int Sx,int Sy)  //zeichnet eine Mausgsteuerte Linie,
{                                   //von Sx,Sy bis zur Mausposition!
 int k;                            //Abbruch durch beliebigen Tastendruck,
 setcolor(Farbe[2]);              //zurckgeliefert wird OTTE-ASCII Wert.
 setwritemode(1);                //in MausX und MausY steht die neuePosition
 line(Sx,Sy,MausX,MausY);
 while(!kbhit())
      {
       GetMouseStatus();
       if(MouseButton!=0)break;
       if((MouseX==MausX)&&(MouseY==MausY)&&(Grafikmodi==1))continue;
       if(((MouseX/8)==MausX)&&((MouseY/8)==MausY)&&(Grafikmodi>1))continue;
       line(Sx,Sy,MausX,MausY);
       if(Grafikmodi>1) MausX=MouseX/8,MausY=MouseY/8;
       else MausX=MouseX,MausY=MouseY;
       line(Sx,Sy,MausX,MausY);
      }
 line(Sx,Sy,MausX,MausY);
 setwritemode(0);
 k=MouseButton;
 if(k==0)                      //Wenn keine Maustaste gedrckt ist
	 {                     //dann wurde die Tastatur bettigt, also
	  k=getch();              //Hole Tastaturcode
	  if(k==0)k=getch()+256;  //Hole erweiterten Tastaturcode
	 }
return (k);
}



int GrafikCursorWindow(int Sx,int Sy)  //zeichnet eine Mausgsteuertes Fenster,
{                                     //von Sx,Sy bis zur Mausposition!
 int k;                              //Abbruch durch beliebigen Tastendruck,
 setcolor(Farbe[2]);                //zurckgeliefert wird OTTE-ASCII Wert.
 setwritemode(1);                  //in MausX und MausY steht die neuePosition
 line(Sx,Sy,MausX,Sy);
 line(MausX,Sy,MausX,MausY);
 line(MausX,MausY,Sx,MausY);
 line(Sx,MausY,Sx,Sy);
 while(!kbhit())
      {
       GetMouseStatus();
       if(MouseButton!=0)break;
       if((MouseX==MausX)&&(MouseY==MausY)&&(Grafikmodi==1))continue;
       if(((MouseX/8)==MausX)&&((MouseY/8)==MausY)&&(Grafikmodi>1))continue;
       line(Sx,Sy,MausX,Sy);
       line(MausX,Sy,MausX,MausY);
       line(MausX,MausY,Sx,MausY);
       line(Sx,MausY,Sx,Sy);
       if(Grafikmodi>1) MausX=MouseX/8,MausY=MouseY/8;
       else MausX=MouseX,MausY=MouseY;
       line(Sx,Sy,MausX,Sy);
       line(MausX,Sy,MausX,MausY);
       line(MausX,MausY,Sx,MausY);
       line(Sx,MausY,Sx,Sy);
      }
 line(Sx,Sy,MausX,Sy);
 line(MausX,Sy,MausX,MausY);
 line(MausX,MausY,Sx,MausY);
 line(Sx,MausY,Sx,Sy);
 setwritemode(0);
 k=MouseButton;
 if(k==0)                      //Wenn keine Maustaste gedrckt ist
	 {                     //dann wurde die Tastatur bettigt, also
	  k=getch();              //Hole Tastaturcode
	  if(k==0)k=getch()+256;  //Hole erweiterten Tastaturcode
	 }
return (k);
}



void MausPosition(int xx,int yy)
{
 MausX=xx;       //setzt den GrafikCursor auf die Angegebene Position
 MausY=yy;
 if(Grafikmodi>1) SetMousePosition(8*xx,8*yy);
 else SetMousePosition(xx,yy);
}



