#include <dos.h>
#include <alloc.h>
#include <time.h>
#include <math.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <vga&bmp.h>
#include <string.h>
#define   MY_SIZE     double   /* or float or long double */
#define   MY_TYPE     huge     /* or far if data fits in two 64 K segments */

extern unsigned _stklen;

extern int grafdriver,Grafikmodi;                     //in Ruhe lassen
extern int MausX,MausY;                               //GrafikCursor-Position
extern int maxx,maxy;                //maximaler Wert fuer X/Y im Grafikmodus
extern int Farbe[20];    // 0-9=Farbe,10-19=Reserviert, siehe auch INI-Datei!
extern int  maxcommands;                    //Anzahl der Commandline Optionen
extern char CommandLine[10][80];            // ARRAY mit Commandline Optionen
extern int  Aktuell;                      // Nummer der ausgewhlten Funktion
extern char AktuellText[81];              //  Name  der ausgewhlten Funktion
extern char AktuellName[81];                       //Name der gewhlten Datei
extern double Puffer[1024];                         //Bildschirm-Daten-Puffer
extern int PufferMAX;                  //Bildschirm-Daten-Puffer Anzahl Werte
extern double huge *real;        //Pointer auf Real - Array
extern double huge *imag;        //Pointer auf Imag.- Array
extern unsigned long size;       //maximale Anzahl der Arrayelemente
extern long AnzahlNormal;              //Anzahl Abtastwerte   wenn Stereo=0
extern long AnzahlReal;                //Anzahl Realwerte     wenn Stereo=1
extern long AnzahlImag;                //Anzahl Imaginrwerte wenn Stereo=1
extern int Stereo;                     //Real & Imaginr, Stereo=1;
extern int FFTflag;                    //Zeitbereich = 0, Frequenzbereich = 1
extern int Nykill;              //Nyquistkriterium=Samplerate/2 wenn Nykill=0
extern double lr,or,ur,rr;             //Randwerte fr GrafikCursorShow...
extern double Samplerate;              //Abtastrate im Zeitbereich
extern double div_Y;                           //Amplitude eines DIV
extern double Xrange,YrangeMAX,YrangeMIN,Yoff; //Scaleing Info...





extern void Kill();
extern void Grafik(int o);
extern void Maus(int o);
extern void saveBMP(int o);
extern void Zeichensatz();
extern int GrafikCursor(int b);
extern int GrafikCursorShow(int b,int z);
extern int GrafikCursorDraw(int b);
extern int GrafikCursorLine(int Xx,int Yy);
extern int GrafikCursorWindow(int Xx,int Yy);
extern void MausPosition(int xx,int yy);
extern int inkey(int o);
extern void zeigeHilfe(char *dateiname);
extern int zeigeMenu();
extern int huge lese_INI_Datei();
extern int zeigeDatei(char *dateiname);
extern void Directory(char *dirEXT,int o);
extern void SOUND_Import(int B16);
extern int loadALL(char *dateiname);
extern int saveALL(char *dateiname);
extern void Import(int o);
extern void Export(int o);
extern void   sing(MY_SIZE MY_TYPE *a, MY_SIZE MY_TYPE *b, long ntot, long n, long nspan, int isn);
extern void realtr(MY_SIZE MY_TYPE *a, MY_SIZE MY_TYPE *b, long half_length,int isn);
extern void fuellen(int ArT);
extern void ZooM(int o);
extern void Visual(int STmode);
extern void Yscale();



/*****************************************************************************
Resampling (oversampling/undersampling) des real/imag Arrays,
es wird sowohl das Reelle als auch das complexe Datenformat untersttzt
(Zeit oder Frequenz), um den Fehler gering zu halten wird linear Interpoliert,
da Gleitkomma-Arithmetik verendet wird ist die virtuelle Mixingrate unendlich.
Undersampling kann zu fragwrdigen Ergebnissen fhren wenn hohe Frequenzen
hoher Amplitude enthalten sind. der bergebene Parameter ist die neue
Arraylnge (AnzahlNormal neu). Damit die Scalierung stimmt wird zustzlich
die Samplerate korrigiert (nur falls ntig).
Fr Dumme: diese Funktion dehnt/staucht das Array auf die angegebene Lnge.
*****************************************************************************/
void Resample(long SAM)
{
long w,k,l;
double a,b,xx,y1,y2,x1,x2;
double e=((double)SAM)/((double)AnzahlNormal);
double f=((double)(SAM-1))/((double)(AnzahlNormal-1));
if (SAM>AnzahlNormal)       //oversampling!
  {
   if (Stereo)
     {
      for(w=SAM-1;w>=0;w--)
         {
          xx=((double)w)/f;  k=(long)xx;  l=k+1;
          x1=(double)k;     x2=x1+1.0;
          y1=real[k];       y2=real[l];
          a=(y1-y2)/(x1-x2);   b=y1-a*x1;
          real[w+2]=xx*a+b;
         }
      for(w=SAM-1;w>=0;w--)
         {
          xx=((double)w)/f;  k=(long)xx;  l=k+1;
          x1=(double)k;     x2=x1+1.0;
          y1=imag[k];       y2=imag[l];
          a=(y1-y2)/(x1-x2);   b=y1-a*x1;
          imag[w+2]=xx*a+b;
         }
      if(FFTflag==0)Samplerate = Samplerate * e;
      AnzahlNormal=SAM;  AnzahlImag=SAM;  AnzahlReal=SAM;
      for(w=0;w<AnzahlReal;w++)real[w]=real[w+2];
      for(w=0;w<AnzahlImag;w++)imag[w]=imag[w+2];
      return;
     }
   else
       {
        for(w=SAM-1;w>=0;w--)
           {
            xx=((double)w)/f;  k=(long)xx;  l=k+1;
            x1=(double)k;     x2=x1+1.0;
            if(k&1)y1=imag[k/2]; else y1=real[k/2];
            if(l&1)y2=imag[l/2]; else y2=real[l/2];
            a=(y1-y2)/(x1-x2);   b=y1-a*x1;
            if(w&1)imag[w/2+2]=xx*a+b; else real[w/2+2]=xx*a+b;
           }
        if(FFTflag==0)Samplerate = Samplerate * e;
        AnzahlNormal=SAM;  AnzahlImag=SAM/2; AnzahlReal=AnzahlImag+(SAM&1);
        for(w=0;w<AnzahlReal;w++)real[w]=real[w+2];
        for(w=0;w<AnzahlImag;w++)imag[w]=imag[w+2];
        return;
       }
  }
if (SAM<AnzahlNormal)       //undersampling!
  {
   if (Stereo)
     {
      for(w=0;w<SAM;w++)
         {
          xx=((double)w)/f;  k=(long)xx;  l=k+1;
          x1=(double)k;      x2=x1+1.0;
          y1=real[k];        y2=real[l];
          a=(y1-y2)/(x1-x2); b=y1-a*x1;
          real[w]=xx*a+b;
         }
      for(w=0;w<SAM;w++)
         {
          xx=((double)w)/f;  k=(long)xx;  l=k+1;
          x1=(double)k;      x2=x1+1.0;
          y1=imag[k];        y2=imag[l];
          a=(y1-y2)/(x1-x2); b=y1-a*x1;
          imag[w]=xx*a+b;
         }
      if(FFTflag==0)Samplerate = Samplerate * e;
      AnzahlNormal=SAM;  AnzahlImag=SAM;  AnzahlReal=SAM;
      return;
     }
   else
       {
        for(w=0;w<SAM;w++)
           {
            xx=((double)w)/f;  k=(long)xx;  l=k+1;
            x1=(double)k;     x2=x1+1.0;
            if(k&1)y1=imag[k/2]; else y1=real[k/2];
            if(l&1)y2=imag[l/2]; else y2=real[l/2];
            a=(y1-y2)/(x1-x2);       b=y1-a*x1;
            if(w&1)imag[w/2]=xx*a+b; else real[w/2]=xx*a+b;
           }
        if(FFTflag==0)Samplerate = Samplerate * e;
        AnzahlNormal=SAM;  AnzahlImag=SAM/2;
        AnzahlReal=AnzahlImag+(SAM&1);
       }
  }
}





void zeigeFaktoren()      //  zeigt viele real/imag-Arraylngen an,
{                         //  die zur FFT geeignet sind (unwichtige Funktion)
 double d;                //  es sind durchaus noch andere Lngen zulssig!
 int a,t=0;
 long o;
 clrscr();
 for(a=0;a<512;a++)
    {
     o=1L<<((a&15)+1);
     if(a& 16)o*= 3L;
     if(a& 32)o*= 5L;
     if(a& 64)o*= 7L;
     if(a&128)o*=11L;
     if(a&256)o*=25L;
     Puffer[a]=(double)o;
    }
 do
   {
    d=1e99;  gotoxy(6*(t/17)+1,t%17+1);
    for(a=0;a<512;a++)if(Puffer[a]<d)d=Puffer[a],o=a;
    Puffer[o]=1e90;  if(d<133)continue;
    t++;  cprintf("%5lg ",d);
   }
 while(d<59000.0);
}





/*****************************************************************************
Funktionen zur Manipulation der Arraylnge, es wird zuerst ein Auswahlmenue
angezeigt, und dann wird die gewhlte Funktion ausgefhrt.

Impossibility drive:    erwartet Eingabe einer Zahl 'n' , ist die Zahl klein
---------------------   wird der Inhalt des Arrays 'n' mal dupliziert, die
Arraylnge ist dann 'n' mal so gross.    Ist 'n' grer als die Arraylnge,
dann wird das Array auf die angegebene Lnge 'n' erweitert indem es mit dem
letzte gegebenen Wert bis 'n' aufgefllt wird.           Arraylnge = n
(ich lasse das Array nicht mit 0 ergnzen um Sprnge zu vermeiden!)
es wird sowohl das Reelle als auch das complexe Datenformat untersttzt.


Oversampling linear:  erwartet Eingabe einer neuen Arraylnge:  Die Daten im
--------------------  Array (Reell oder Complex, Zeit- oder Freqenzbereich)
werden auf die neue Lnge gedehnt/gestaucht (Resampling). Um den Fehler gering
zu halten wird linear Interpoliert, Damit die Scalierung stimmt wird falls
ntig zustzlich noch die Samplerate korrigiert.


Oversampling Filter:  wie Oversampling linear, allerdings sind nur reelle
--------------------  Daten bis zu einer Datenlnge von etwa 22000 zugelassen!
dieses Oversampling/Undersampling wird ber die Verallgemeinerte Abtastreihe
realisiert, dazu wird ein KVAR (Kern fr verallgemeinerte Abtastreihen)
bentigt, der im *.FFT Format vorzuliegen hat, mit einer Datenlnge von 16384
und im Zeitbereich reell ist. Da der KVAR eine gerade reelle Funktion ist,
die auerdem noch stetig und beschrnkt ist wird nur die zweite Hlfte
gelesen und linear interpoliert um die Auflsung zu verbessern...
*****************************************************************************/
void Xscale()
{
 FILE *fp;
 int c;
 double d,e,b,z,s;
 long w,m,n,h;
 Grafik(1);  Kill();  settextstyle(0,0,4);
 setcolor(Farbe[3]);
 outtextxy(22,(1*maxy)/6,"Impossibility Drive");
 outtextxy(22,(3*maxy)/6,"Oversampling Linear");
 outtextxy(22,(5*maxy)/6,"Oversampling Filter");
 setcolor(Farbe[2]);
 outtextxy(21,(1*maxy)/6-1,"Impossibility Drive");
 outtextxy(21,(3*maxy)/6-1,"Oversampling Linear");
 outtextxy(21,(5*maxy)/6-1,"Oversampling Filter");
 setcolor(Farbe[1]);
 outtextxy(20,(1*maxy)/6-2,"Impossibility Drive");
 outtextxy(20,(3*maxy)/6-2,"Oversampling Linear");
 outtextxy(20,(5*maxy)/6-2,"Oversampling Filter");
 c=GrafikCursor(100);
 inkey(0);
 Grafik(0);
 Zeichensatz();
 if(c==27)return;
 c=(3*MausY)/maxy;
 if(c==0)
   {
    m=size*(2L-Stereo);   zeigeFaktoren();
    if((m/AnzahlNormal)>1)cprintf("  \n\nMultiply = 1...%ld",m/AnzahlNormal);
    cprintf("\n\n\rFilling = %ld...%ld\n\n\r? ",AnzahlNormal+1,m);
    scanf("%ld",&w);   fflush(stdin);
    if((w<2)||(w>m))return;
    if((w>(m/AnzahlNormal))&&(w<(AnzahlNormal+1)))return;
    if(w<AnzahlNormal)        //multiply
      {
       for(m=AnzahlNormal; m<(w*AnzahlNormal); m+=AnzahlNormal)
          {
           for(n=0;n<AnzahlNormal;n++)
              {
               if(Stereo)real[m+n]=real[n],imag[m+n]=imag[n];
               else
                   {
                    if(n&1)d=imag[n/2L]; else d=real[n/2L];
                    if((m+n)&1)imag[(m+n)/2L]=d; else real[(m+n)/2L]=d;
                   }
              }
          }
       AnzahlNormal=AnzahlNormal*w;
       AnzahlImag = AnzahlNormal/2L;      AnzahlReal=AnzahlImag+(w&1);
       if(Stereo) AnzahlImag=AnzahlNormal,AnzahlReal=AnzahlNormal;
       return;
      }
    n=AnzahlNormal-1;                          //filling
    if(n&1)d=imag[n/2L]; else d=real[n/2L];
    for(m=AnzahlNormal;m<w;m++)
       {
        if(Stereo)real[m]=real[n],imag[m]=imag[n];
        else { if(m&1)imag[m/2L]=d; else real[m/2L]=d; }
       }
    AnzahlNormal=w;  AnzahlImag=w/2;  AnzahlReal=AnzahlImag+(w&1);
    if (Stereo)      AnzahlImag=w,    AnzahlReal=w;
    return;
   }
 if(c==1)    //linear oversampling
   {
    zeigeFaktoren();
    cprintf("  \n\nold = %ld DATAs\n\n\r",AnzahlNormal);
    cprintf("new (2...%ld) = ",size*(2-Stereo));
    scanf("%ld",&w);   fflush(stdin);
    if(w>(size*(2-Stereo)))return;
    if(w<2)return;
    if(w>AnzahlNormal)cprintf("\nlinear Oversampling...");
    else cprintf("\nlinear Undersampling...");
    Resample(w);
    return;
   }
 if(c==2)     //Filter oversampling
   {
    if(Stereo)return;                //not reell data
    if(AnzahlNormal>=size)return;    //too big!
    Directory("*.FFT",0);   c=zeigeDatei("TMP.TMP");   inkey(0);
    if((c==27)||(c<1))return;
    zeigeFaktoren();  cprintf("  \nFilter = %s\n\n\r",AktuellName);
    strcat(AktuellName,".FFT");  cprintf("old = %ld DATAs",AnzahlNormal);
    cprintf("\n\n\rnew (2...%ld) = ",2L*size);
    fp=fopen(AktuellName,"rb");   if(fp==NULL)return;
    fread(&w,4,1,fp);   fread(&m,4,1,fp);
    fread(&n,4,1,fp);   fread(&n,4,1,fp);
    if(w!=0)          { fclose(fp); return; }  //not reeller Filter
    if(m!=16384)      { fclose(fp); return; }  //false length
    fread(&d,8,1,fp);   scanf("%ld",&w);   fflush(stdin);
    if(w>=(2L*size))  { fclose(fp); return; }  //too big!
    if(w<2)           { fclose(fp); return; }  //too small
    _setcursortype(0); if(w>AnzahlNormal)cprintf("\nOversampling");
    else cprintf("\nUndersampling");
    z=16384.0/d;        z=z/2.0;    // z=T (halbe Dauer)
    b=16384.0/z;   e=(((double)AnzahlNormal)-1.0)/(((double)w)-1.0);
    for(m=AnzahlNormal-1;m>=0;m--)             //real = reell...
       {
        if(m&1)real[m]=imag[m/2L]; else real[m]=real[m/2L];
       }
    for(m=0;m<4096;m++) fread(&d,8,1,fp);      //ignoriere erste Filterhlfte
    for(m=0;m<4096;m++){fread(&d,8,1,fp); imag[m*4L]=d;} //lese zweite Hlfte
    for(m=0;m<4096;m++) fread(&d,8,1,fp);      //ignoriere erste Filterhlfte
    for(m=0;m<4096;m++){fread(&d,8,1,fp); imag[m*4L+2L]=d;} //lese 2te Hlfte
    fclose(fp);  imag[16384]=0.0;  imag[16385]=0.0;  imag[16386]=0.0;
    for(m=0;m<8192;m++)                        //mitteln fr mehr Genauigkeit
       {
        n=m*2L;
        imag[n+1L]=(imag[n]+imag[n+2L])/2.0;
       }

    fp=fopen("TMP.TMP","wb");   if(fp==NULL)return;
    for(m=0,c=0;m<w;m++)                               //Abtastreihe mit KVAR
       {
        h=m*100L/w;  if(h>c){c=h; gotoxy(20,25); cprintf("%d\45",c); }
        n = ( e * ((double)m) -z -1.0);      //dynamic startposition
        if(n<0)n=0;                         //korrekt?
        for(s=0.0;n<AnzahlNormal;n++)
           {
            d = e * ((double)m) - ((double)n);
            if(d>=z)continue;
            if(d<=-z)break;
            s+=(real[n]*imag[fabs(d*b)]);
           }
        fwrite(&s,8,1,fp);
       }
    fclose(fp);  fp=fopen("TMP.TMP","rb");   if(fp==NULL)return;  //lesen
    for(m=0;m<w;m++)
       {
        fread(&d,8,1,fp);
        if(m&1)imag[m/2L]=d; else real[m/2L]=d;
       }
    e=((double)AnzahlNormal)/((double)w);
    AnzahlNormal=w;  AnzahlImag=w/2L;  AnzahlReal=AnzahlImag+(w&1);
    fclose(fp);      if(FFTflag==0)Samplerate=Samplerate/e;
   }
}

